Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class VersionSeries

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.PublicObject
                  oracle.ifs.beans.TiePublicObject
                      oracle.ifs.beans.VersionSeries

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  TieVersionSeries

    public class VersionSeries

extends TiePublicObject

The VersionSeries class is used to track revisions to a versioned public object as it changes over time. Each series tracks one set of linear changes by ordering instances of VersionDescription. A Family can have multiple VersionSeries, thus allowing for version branching or other non-linear version tracking. A VersionSeries has two special attributes, DefaultVersionDescription and LastVersionDescription. The defaultVersionDescription is fully updatable and can be used to designate a Published version in which people not actively working on a versioned object might be interested. The LastVersion is more useful for someone actively working on a versioned object; the last version might represent work in progress and as such might not be appropriate for a public audience. The last version is system maintaned.

If a DefaultVersionDescription is not set (is null) then a request for a resolved public object will be deferred to the last version description.

The VersionSeries class has methods to checkOut (aka reserveNext()), checkIn (aka newRevision) and cancelCheckOut (aka unReserve) a document belonging to this series. Invoking these methods can affect the lock state of the various versioning objects such as Family, VersionSeries etc. Prior to 9.0.3, the behavior was as follows:

- As part of a checkOut() operation, the Family, VersionSeries, Last VersionDescription and PublicObject are UserLocked.
- As part of a checkIn() operation, the Last VersionDescription and PublicObject (before the new version) are SoftLocked. This is to prevent previous versions from being modified.
- As part of a cancelCheckOut() operation, the Family, VersionSeries, Last VersionDescription and PublicObject are UnLocked.

Starting in 9.0.3, policies on the VersionSeries class or instance can be introduced which control what versioning objects are locked during these operations. This is fully customizable according to the needs of the application.

Out-of-the-box, there are six policies for the three versioning operations. The policy names and their semantics are defined below as static constants. To switch the policy associated with the VersionSeries class for a particular operation, find the policy by name that you wish to switch to from the PolicyBundle collection on the session. Associate the policy with the VersionSeries ClassObject or the instance by using `LibraryObject.putPolicy(Policy po)`. Associating with the VersionSeries ClassObject affects all VersionSeries in the system while associating it with the instance only applies that policy for that instance.

To define a totally new policy with a custom semantic for a particular operation, construct a policy object using the API. Details on how to create a new policy are in the Developers guide. The "Operation" attribute of the new policy must be equal to the Operation for which you are trying to change the default policy. This is stored in the "Operation" attribute of the default Policy Object. The implementation for the policy must reside in the server side subclass of VersionSeries class i.e. S_TieVersionSeries or its subclass. The implementation method must also take a server side S_LibraryObjectDefinition as a parameter and be public. The implementation is dynamically invoked. <

For more details on Policies, refer to the documentation for the Policy class.
For a description of the various lock states, refer to the documentation for the LockObject class.

(Published)

Field Summary
`static java.lang.String` | `CLASS_NAME` The class name for this class.
`static java.lang.String` | `DEFAULTVERSIONDESCRIPTION_ATTRIBUTE` The VersionDescription which will be used as the ResolvedPublicObject for this VersionSeries.
`static java.lang.String` | `LASTVERSIONDESCRIPTION_ATTRIBUTE` The last VersionDescription in this VersionSeries.
`static java.lang.String` | `LOCK_ON_NEW_VERSION_POLICY_LOCK_ALL` The out-of-the-box versioning policy for newVersion aka checkIn operation.
`static java.lang.String` | `LOCK_ON_NEW_VERSION_POLICY_LOCK_NONE` An alternate versioning policy for newVersion aka checkIn operation.
`static java.lang.String` | `LOCK_ON_RESERVE_NEXT_POLICY_LOCK_ALL` The out-of-the-box versioning policy for reserveNext aka checkOut operation.
`static java.lang.String` | `LOCK_ON_RESERVE_NEXT_POLICY_LOCK_NONE` An alternate versioning policy for reserveNext aka checkOut operation.
`static java.lang.String` | `PENDINGPUBLICOBJECT_ATTRIBUTE` A PublicObject which allows incremental archiving of work in progress while a VersionSeries is reserved.
`static java.lang.String` | `RESERVATIONCOMMENT_ATTRIBUTE` The check-out comment stating the purpose of the reservation.
`static java.lang.String` | `RESERVATIONDATE_ATTRIBUTE` The date and time (in GMT) when the VersionSeries was reserved.
`static java.lang.String` | `RESERVOR_ATTRIBUTE` The DirectoryUser that has this VersionSeries reserved for the purpose of adding a new version.
`static java.lang.String` | `UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_ALL` The out-of-the-box versioning policy for Unreserve aka cancelCheckOut operation.
`static java.lang.String` | `UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_NONE` An alternate versioning policy for unReserve aka cancelCheckOut operation.
`static java.lang.String` | `VERSIONLIMIT_ATTRIBUTE` The limit of the number of versions which this VersionSeries should keep.
`static java.lang.String` | `WORKPATH_ATTRIBUTE` The location of a version's content on the client's local store.

Fields inherited from class oracle.ifs.beans.PublicObject
`ACL_ATTRIBUTE, CREATEDATE_ATTRIBUTE, CREATOR_ATTRIBUTE, DELETOR_ATTRIBUTE, DESCRIPTION_ATTRIBUTE, EXPIRATIONDATE_ATTRIBUTE, FAMILY_ATTRIBUTE, FLAG_CATEGORY_EXISTS, FLAG_CONFIGURATIONCATEGORY_EXISTS, FLAG_MARKED, FLAG_NOINFERIOR, FLAG_NOSELECT, FLAG_NTFS_ARCHIVE, FLAG_NTFS_HIDDEN, FLAG_NTFS_READONLY, FLAG_NTFS_SYSTEM, FLAG_UNMARKED, FLAGS_ATTRIBUTE, LASTMODIFIER_ATTRIBUTE, LASTMODIFYDATE_ATTRIBUTE, LOCKENTRIES_ATTRIBUTE, LOCKOBJECT_ATTRIBUTE, NAME_ATTRIBUTE, OWNER_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PRIMARYPARENTFOLDER_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE, RESOLVEDPUBLICOBJECT_ATTRIBUTE, SECURINGPUBLICOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `VersionSeries(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Construct a VersionSeries object - standard variant.

Method Summary
`protected static VersionSeries` | `constructVersionSeries(LibrarySession sess, S_LibraryObjectData data)` Constructs a VersionSeries from data corresponding to it.
`protected static VersionSeries[]` | `constructVersionSeriesArray(LibrarySession sess, java.lang.Long[] ids)` Construct a Version Series array from an array of object IDs.
`protected static java.util.Vector` | `constructVersionSeriesVector(LibrarySession sess, java.util.Vector vector)` Constructs a vector of VersionSeries objects from a vector of data objects corresponding to it.
`VersionDescription` | `createBranchedVersionSeries(VersionDescriptionDefinition vddef)` Creates a branched version series in this family, which relates back to the latest version description in this series.
`BranchRelationship[]` | `getChildBranchRelationships()` Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a parent (the other series are the child).
`BranchRelationship[]` | `getChildBranchRelationships(ClassObject relClass, SortSpecification sortSpec)` Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a parent (the other series are the child).
`static java.lang.Long` | `getClassId(LibrarySession session)` Get the ID of the ClassObject representing VERSIONSERIES.
`VersionDescription` | `getDefaultVersionDescription()` Returns the default version of this version series.
`VersionDescription` | `getFirstVersionDescription()` Returns the first VersionDescription of this series.
`VersionDescription` | `getLastVersionDescription()` Returns the last VersionDescription of this series.
`VersionDescription` | `getNextVersionDescription(VersionDescription version)` Returns the next VersionDescription of this series.
`BranchRelationship[]` | `getParentBranchRelationships()` Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a child (the other series are the parent).
`BranchRelationship[]` | `getParentBranchRelationships(ClassObject relClass, SortSpecification sortSpec)` Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a child (the other series are the parent).
`PublicObject` | `getPendingPublicObject()` Returns the pending PublicObject that will become the next version upon a newVersion() invocation.
`VersionDescription` | `getPreviousVersionDescription(VersionDescription version)` Returns the Version description previous to the one being passed by the user.
`java.lang.String` | `getReservationComment()` Returns the comment when this series was reserved, or null if this series is not reserved.
`java.util.Date` | `getReservationDate()` Returns the Date that this VersionSeries was reserved, null if not reserved.
`DirectoryUser` | `getReservor()` Returns the User that reserved this VersionSeries, null if not reserved
`PublicObject` | `getResolvedPublicObject()` Return the PublicObject to which this object resolves.
`VersionDescription[]` | `getVersionDescriptions()` Returns an array of all VersionDescriptions in this VersionSeries.
`VersionDescription` | `getVersionDescriptions(int index)` Returns the specified VersionDescription of this series.
`VersionDescription[]` | `getVersionDescriptions(PublicObject version)` Returns an array of VersionDescriptions which reference the versioned public object passed in (more than one VersionDescription can refer to the same PublicObject).
`int` | `getVersionLimit()` Gets the value of the VersionLimit attribute.
`VersionSeries` | `getVersionSeries()` Override to PublicObject.getVersionSeries(); returns this.
`PublicObject` | `getWorkingCopy()` Returns the "working copy".
`java.lang.String` | `getWorkpath()` Returns the value for the local file path specified when this series was reserved.
`boolean` | `isLatestVersionDescription(VersionDescription version)` Returns true if the specified VersionDescription is the latest in this series.
`boolean` | `isReserved()` Returns true if this VersionSeries is reserved by any user.
`boolean` | `isReservedByCurrentUser()` Returns true if this VersionSeries is reserved by the current user.
`boolean` | `isVersioned()` Returns false always.
`VersionDescription` | `newVersion(VersionDescriptionDefinition vddef)` Creates a new VersionDescription in this series from the specified VersionDescriptionDefinition.
`void` | `reserveNext(java.lang.String contentPath, java.lang.String comment)` Reserves the right to add the next version.
`protected void` | `resetVersionDescriptions()` Clear locally cached list of Versions.
`void` | `setDefaultVersionDescription(VersionDescription version)` Set the Default Version Description of this series.
`void` | `setPendingPublicObject(PublicObject po)` Sets the pending PublicObject that will become the next version upon a newVersion() invocation.
`void` | `setVersionLimit(int limit)` Sets the value of the VersionLimit attribute.
`void` | `unReserve()` Cancels the reservation.
`protected static VersionSeries[]` | `vectorToVersionSeriesArray(java.util.Vector vector)` Returns an array of VersionSeries objects from a vector of VersionSeries objects.
`protected static VersionSeries` | `vectorVersionSeriesElement(java.util.Vector vector, int index)` Get a VersionSeries out of a Vector of VersionSeries.

Methods inherited from class oracle.ifs.beans.PublicObject
`addAccess, addCategory, addFlags, addRelationship, auditPublicObjectLocked, auditPublicObjectUnlocked, canAcquireManualLock, canReleaseDavLock, canReleaseLock, canReleaseManualLock, capabilities, checkAuditViewCapability, checkCapabilities, checkCapability, checkEffectiveAccess, checkEffectiveAccess, checkLockAccess, checkVersioned, clearFlags, constructPublicObject, constructPublicObjectArray, constructPublicObjectVector, copy, coreAutoFolderingEnabled, createCategories, createDedicatedPolicyPropertyBundle, delete, deriveEffectiveAccessLevel, free, getAcl, getAllFolderPaths, getAllFolderPaths, getAllFolderPaths, getAnyFolderPath, getAnyFolderPath, getAnyFolderPath, getCapabilities, getCategories, getCategories, getCategories, getCategories, getCategories, getCategory, getConsumedStorage, getCreateDate, getCreator, getDefaultAccessLevel, getDeletor, getDescription, getEffectiveAccessLevel, getEffectiveAccessLevel, getExpirationDate, getFamily, getFirstVersion, getFlags, getFolderReferences, getFolderReferences, getFolderReferencesSortSpecification, getLastModifier, getLastModifyDate, getLastVersion, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getLeftwardRelationshipsCount, getLeftwardRelationshipsCount, getLinks, getLockEntries, getLockEntries, getLockObject, getLockRestrictions, getLockTypeAuditProperties, getNextVersion, getOwner, getPolicyBundle, getPolicyLists, getPreviousVersion, getPrimaryFolderPath, getPrimaryParentFolder, getPrimaryParentFolder, getRestrictingLockEntries, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getSecuringPublicObject, getSingletonVersionDescription, getVersionNumber, getVersions, grantAccess, handleCopy, handleCreate, handleUnlockAll, hasCategories, hasConfigurationCategories, hasNameAttribute, isDeleted, isLatestVersion, isLocked, isLockingSupported, isOwner, isVersionable, isWorkingCopy, listLeftwardRelationships, listRightwardRelationships, lock, lock, lock, lock, postCopy, postCreate, postUpdate, preCopy, preCreate, preFree, preUpdate, putPolicy, reassociateLinks, removeAllPolicies, removePolicy, removePolicy, removeRelationship, resetFolderReferences, resolveFolderReferenceSortSpecification, revokeAccess, revokeAllAccess, setAcl, setDescription, setExpirationDate, setFlags, setFolderReferencesSortSpecification, setLockEntries, setLockEntrySecurity, setOwner, setOwnerByName, setPolicyBundle, setPolicyLists, setSecuringPublicObject, toPublicObjectArray, undelete, unlock, unlock, unlockAll, updateFlags, updateLock, vectorPublicObjectElement, vectorToPublicObjectArray, verifyDeleteCapability, verifyLockCapability, verifyUnlockCapability, verifyVersionSeries`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, auditUpdated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getLabel, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleAdminModeChange, handleEvent, handleFree, handleUpdate, hashCode, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, isValidEventType, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, prePostAuditEvent, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, validatePropertyValues, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `VersionSeries`
  The class name for this class. Useful for methods that take a class name argument.

  See Also:
    Constant Field Values
  (Published)

### DEFAULTVERSIONDESCRIPTION_ATTRIBUTE

    public static final java.lang.String DEFAULTVERSIONDESCRIPTION_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The VersionDescription which will be used as the ResolvedPublicObject for this VersionSeries. If null, the ResolvedPublicObject for this VersionSeries will be the LastVersionDescription.

  See Also:
    Constant Field Values
  (Published)

### LASTVERSIONDESCRIPTION_ATTRIBUTE

    public static final java.lang.String LASTVERSIONDESCRIPTION_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The last VersionDescription in this VersionSeries.

  See Also:
    Constant Field Values
  (Published)

### RESERVOR_ATTRIBUTE

    public static final java.lang.String RESERVOR_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The DirectoryUser that has this VersionSeries reserved for the purpose of adding a new version. If the VersionSeries is not reserved, the Reservor is null.

  See Also:
    Constant Field Values
  (Published)

### RESERVATIONDATE_ATTRIBUTE

    public static final java.lang.String RESERVATIONDATE_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The date and time (in GMT) when the VersionSeries was reserved.

  See Also:
    Constant Field Values
  (Published)

### RESERVATIONCOMMENT_ATTRIBUTE

    public static final java.lang.String RESERVATIONCOMMENT_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The check-out comment stating the purpose of the reservation.

  See Also:
    Constant Field Values
  (Published)

### WORKPATH_ATTRIBUTE

    public static final java.lang.String WORKPATH_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The location of a version's content on the client's local store. WorkPath is a convenience attribute to allow clients to record the location of a version that has been checked out.

  See Also:
    Constant Field Values
  (Published)

### VERSIONLIMIT_ATTRIBUTE

    public static final java.lang.String VERSIONLIMIT_ATTRIBUTE

  Description copied from class: `VersionSeries`
  The limit of the number of versions which this VersionSeries should keep. The VersionLimit is an advisory attribute to be used by an agent in VersionPurging operations. The Repository does not act on this attribute.

  See Also:
    Constant Field Values
  (Published)

### PENDINGPUBLICOBJECT_ATTRIBUTE

    public static final java.lang.String PENDINGPUBLICOBJECT_ATTRIBUTE

  Description copied from class: `VersionSeries`
  A PublicObject which allows incremental archiving of work in progress while a VersionSeries is reserved.

  See Also:
    Constant Field Values
  (Unpublished)

### LOCK_ON_RESERVE_NEXT_POLICY_LOCK_ALL

    public static final java.lang.String LOCK_ON_RESERVE_NEXT_POLICY_LOCK_ALL

  Description copied from class: `VersionSeries`
  The out-of-the-box versioning policy for reserveNext aka checkOut operation. This is the default policy associated out-of-the-box with the VersionSeries class.
  The out-of-the-box policy will UserLock the Family, VersionSeries, Last VersionDescription and ResolvedPublicObject on checking out a Document.

  See Also:
    Constant Field Values
  (Published)

### LOCK_ON_NEW_VERSION_POLICY_LOCK_ALL

    public static final java.lang.String LOCK_ON_NEW_VERSION_POLICY_LOCK_ALL

  Description copied from class: `VersionSeries`
  The out-of-the-box versioning policy for newVersion aka checkIn operation. This is the default policy associated out-of-the-box with the VersionSeries class.
  The out-of-the-box policy will SoftLock the Last VersionDescription and PublicObject (before the new one) on checking in a Document. The repository uses the standard SystemLockObject "SystemSoftLock" to soft lock these objects. SystemLockObject is a LockObject that is name unique in the system.

  See Also:
    `SystemLockObject`, Constant Field Values
  (Published)

### UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_ALL

    public static final java.lang.String UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_ALL

  Description copied from class: `VersionSeries`
  The out-of-the-box versioning policy for Unreserve aka cancelCheckOut operation. This is the default policy associated out-of-the-box with the VersionSeries class.
  The out-of-the-box policy will unlock the Family, VersionSeries, Last VersionDescription and PublicObject on canceling the reserveNext operation.

  See Also:
    Constant Field Values
  (Published)

### LOCK_ON_RESERVE_NEXT_POLICY_LOCK_NONE

    public static final java.lang.String LOCK_ON_RESERVE_NEXT_POLICY_LOCK_NONE

  Description copied from class: `VersionSeries`
  An alternate versioning policy for reserveNext aka checkOut operation. Associating this policy with the VersionSeries class or instance will not lock any versioning objects as part of the check Out operation.

  See Also:
    Constant Field Values
  (Published)

### LOCK_ON_NEW_VERSION_POLICY_LOCK_NONE

    public static final java.lang.String LOCK_ON_NEW_VERSION_POLICY_LOCK_NONE

  Description copied from class: `VersionSeries`
  An alternate versioning policy for newVersion aka checkIn operation. Associating this policy with the VersionSeries class or instance will not lock any versioning objects as part of the checkIn operation.

  See Also:
    Constant Field Values
  (Published)

### UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_NONE

    public static final java.lang.String UNLOCK_ON_UNRESERVE_POLICY_UNLOCK_NONE

  Description copied from class: `VersionSeries`
  An alternate versioning policy for unReserve aka cancelCheckOut operation. Associating this policy with the VersionSeries class or instance will not lock any versioning objects as part of the cancelCheckOut operation.

  See Also:
    Constant Field Values
  (Published)

Constructor Detail

### VersionSeries

    protected VersionSeries(LibrarySession session,
                            java.lang.Long id,
                            java.lang.Long classId,
                            S_LibraryObjectData data)
                     throws IfsException

  Construct a VersionSeries object - standard variant.

  Parameters:
    `session` - current LibSession
    `id` - object ID
    `classId` - class ID
    `data` - object data
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Method Detail

### getClassId

    public static java.lang.Long getClassId(LibrarySession session)
                                     throws IfsException

  Description copied from class: `VersionSeries`
  Get the ID of the ClassObject representing VERSIONSERIES.

  Parameters:
    `session` - the session context
  Returns:
    the ID of the VERSIONSERIES ClassObject
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getVersionSeries

    public VersionSeries getVersionSeries()
                                   throws IfsException

  Description copied from class: `VersionSeries`
  Override to PublicObject.getVersionSeries(); returns this.

  Overrides:
    `getVersionSeries` in class `PublicObject`
  Returns:
    the target VersionSeries
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getReservationComment

    public java.lang.String getReservationComment()
                                           throws IfsException

  Description copied from class: `VersionSeries`
  Returns the comment when this series was reserved, or null if this series is not reserved.

  Overrides:
    `getReservationComment` in class `PublicObject`
  Returns:
    the reservation comment.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefaultVersionDescription

    public VersionDescription getDefaultVersionDescription()
                                                    throws IfsException

  Description copied from class: `VersionSeries`
  Returns the default version of this version series.

  Returns:
    the default version of this version series.
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails
  (Published)

### setDefaultVersionDescription

    public void setDefaultVersionDescription(VersionDescription version)
                                      throws IfsException

  Description copied from class: `VersionSeries`
  Set the Default Version Description of this series.

  Parameters:
    `version` - the desired default VersionDescription.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isLatestVersionDescription

    public boolean isLatestVersionDescription(VersionDescription version)
                                       throws IfsException

  Description copied from class: `VersionSeries`
  Returns true if the specified VersionDescription is the latest in this series.

  Parameters:
    `version` - the relevent VersionDescription
  Returns:
    true if the specified VersionDescription is the latest in this series.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getVersionDescriptions

    public VersionDescription[] getVersionDescriptions(PublicObject version)
                                                throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of VersionDescriptions which reference the versioned public object passed in (more than one VersionDescription can refer to the same PublicObject).

  Parameters:
    `version` - PublicObject version
  Returns:
    array of VersionDescriptions which contain the public object passed in.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isReserved

    public boolean isReserved()
                       throws IfsException

  Description copied from class: `VersionSeries`
  Returns true if this VersionSeries is reserved by any user.

  Overrides:
    `isReserved` in class `PublicObject`
  Returns:
    true if this VersionSeries is reserved by any user.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isReservedByCurrentUser

    public boolean isReservedByCurrentUser()
                                    throws IfsException

  Description copied from class: `VersionSeries`
  Returns true if this VersionSeries is reserved by the current user.

  Overrides:
    `isReservedByCurrentUser` in class `PublicObject`
  Returns:
    true if this VersionSeries is reserved by the current user.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getReservor

    public DirectoryUser getReservor()
                              throws IfsException

  Description copied from class: `VersionSeries`
  Returns the User that reserved this VersionSeries, null if not reserved

  Overrides:
    `getReservor` in class `PublicObject`
  Returns:
    the User that reserved this VersionSeries, null if not reserved
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails
  (Published)

### getReservationDate

    public java.util.Date getReservationDate()
                                      throws IfsException

  Description copied from class: `VersionSeries`
  Returns the Date that this VersionSeries was reserved, null if not reserved.

  Overrides:
    `getReservationDate` in class `PublicObject`
  Returns:
    the Date that this VersionSeries was reserved, null if not reserved.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getWorkingCopy

    public PublicObject getWorkingCopy()
                                throws IfsException

  Description copied from class: `VersionSeries`
  Returns the "working copy".

  This VersionSeries must already be checked-out by the same user, or else a null is returned.

  Overrides:
    `getWorkingCopy` in class `PublicObject`
  Returns:
    the working copy; returns null if there is no working copy or if the VersionSeries is reserved by another user.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getPendingPublicObject

    public PublicObject getPendingPublicObject()
                                        throws IfsException

  Description copied from class: `VersionSeries`
  Returns the pending PublicObject that will become the next version upon a newVersion() invocation.

  Returns:
    the pending PublicObject, or null if none.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setPendingPublicObject

    public void setPendingPublicObject(PublicObject po)
                                throws IfsException

  Description copied from class: `VersionSeries`
  Sets the pending PublicObject that will become the next version upon a newVersion() invocation.

  Parameters:
    `po` - the new PublicObject that will become the next version upon a newVersion() invocation.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getResolvedPublicObject

    public PublicObject getResolvedPublicObject()
                                         throws IfsException

  Description copied from class: `VersionSeries`
  Return the PublicObject to which this object resolves. For the non version classes (for example, Document and Folder) this simply returns itself (`this`). For the version classes, (Family, VersionSeries, and VersionDescription), this will return a non version-class object as determined by the configuration of the instance of the version class.

  This override exists to return the Pending PublicObject value if the caller is the Reservor of this VersionSeries; in all other cases, it defers to the imlementation in the superclass (PublicObject).

  Overrides:
    `getResolvedPublicObject` in class `PublicObject`
  Returns:
    PublicObject that this object resolves to
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `PublicObject.getResolvedPublicObject()`
  (Published)

### getVersionLimit

    public int getVersionLimit()
                        throws IfsException

  Description copied from class: `VersionSeries`
  Gets the value of the VersionLimit attribute. This value is used for advisory purposes only, as is not acted upon by the iFS server. It can be used in conjunction with (for example) a custom agent that may use this value to decide to delete old versions in this VersionSeries.

  Returns:
    the advisory version limit. Returns 0 if no value is specified.
  Throws:
    `IfsException`

### setVersionLimit

    public void setVersionLimit(int limit)
                         throws IfsException

  Description copied from class: `VersionSeries`
  Sets the value of the VersionLimit attribute. This value is used for advisory purposes only, as is not acted upon by the core iFS server. It can be used in conjunction with (for example) a custom agent that may use this value to decide to delete old versions in this VersionSeries.

  Equivalent to:

       AttributeValue av = AttributeValue.newAttributeValue(implementation);
       setAttribute(VERSIONLIMIT_ATTRIBUTE, av);

  Parameters:
    `limit` - the advisory version limit.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getFirstVersionDescription

    public VersionDescription getFirstVersionDescription()
                                                  throws IfsException

  Description copied from class: `VersionSeries`
  Returns the first VersionDescription of this series.

  Returns:
    the first VersionDescription of this series.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLastVersionDescription

    public VersionDescription getLastVersionDescription()
                                                 throws IfsException

  Description copied from class: `VersionSeries`
  Returns the last VersionDescription of this series.

  Returns:
    the last VersionDescription of this series.
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails
  (Published)

### getNextVersionDescription

    public VersionDescription getNextVersionDescription(VersionDescription version)
                                                 throws IfsException

  Description copied from class: `VersionSeries`
  Returns the next VersionDescription of this series.

  Returns:
    the next VersionDescription of this series.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getPreviousVersionDescription

    public VersionDescription getPreviousVersionDescription(VersionDescription version)
                                                     throws IfsException

  Description copied from class: `VersionSeries`
  Returns the Version description previous to the one being passed by the user.

  Parameters:
    `version` - some VersionDescription in the series
  Returns:
    the previous VersionDescription
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getWorkpath

    public java.lang.String getWorkpath()
                                 throws IfsException

  Description copied from class: `VersionSeries`
  Returns the value for the local file path specified when this series was reserved. This information is maintained as a convenience. It is not used (nor validated) by the server.

  Returns:
    the local work path, or null if not reserved.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### unReserve

    public void unReserve()
                   throws IfsException

  Description copied from class: `VersionSeries`
  Cancels the reservation. Resets the Reservation Comment and the WorkPath.

  Overrides:
    `unReserve` in class `PublicObject`
  Throws:
    `IfsException` - if operation fails.
  (Published)

### newVersion

    public VersionDescription newVersion(VersionDescriptionDefinition vddef)
                                  throws IfsException

  Description copied from class: `VersionSeries`
  Creates a new VersionDescription in this series from the specified VersionDescriptionDefinition. Updates the LastVersionDescription attribute. Unreserves the series, resetting the Reservation Comment and WorkPath attributes.

  Overrides:
    `newVersion` in class `PublicObject`
  Parameters:
    `vddef` - VersionDescriptionDefinition
  Returns:
    the version description that was created
  Throws:
    `IfsException` - if operation fails.
  (Published)

### reserveNext

    public void reserveNext(java.lang.String contentPath,
                            java.lang.String comment)
                     throws IfsException

  Description copied from class: `VersionSeries`
  Reserves the right to add the next version. This locks the series against additional versions by anyone else. A locked VersionSeries cannot be deleted; Checking in or canceling checkout will unreserve the series. Path being passed as parameter, is for convenience only and is not used or validated.

  Overrides:
    `reserveNext` in class `PublicObject`
  Parameters:
    `contentPath` - path to local file of reserved content
    `comment` - Check in comment.
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `VersionSeries`
  (Published)

### createBranchedVersionSeries

    public VersionDescription createBranchedVersionSeries(VersionDescriptionDefinition vddef)
                                                   throws IfsException

  Description copied from class: `VersionSeries`
  Creates a branched version series in this family, which relates back to the latest version description in this series. Note that since a version series must have at least one VersionDescription, this method takes a VersionDescriptionDefinition and creates that also; If the VersionDescriptionDefinition does not contain a VersionSeriesDefinition, then a default one will be used to create the branched VersionSeries. Note that the new branched VersionSeries can be made the primary via the `setPrimaryVersionSeries()` method.

  Parameters:
    `vddef` - Definition object describing the first VersionDescription in the new VersionSeries.
  Throws:
    `IfsException` - on failure
  (Unpublished)

### getVersionDescriptions

    public VersionDescription[] getVersionDescriptions()
                                                throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of all VersionDescriptions in this VersionSeries.

  Returns:
    all VersionDescriptions in this VersionSeries.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getVersionDescriptions

    public VersionDescription getVersionDescriptions(int index)
                                              throws IfsException

  Description copied from class: `VersionSeries`
  Returns the specified VersionDescription of this series.

  Returns:
    the specified VersionDescription of this series.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getParentBranchRelationships

    public BranchRelationship[] getParentBranchRelationships()
                                                      throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a child (the other series are the parent).

  Returns:
    array of parent branch relationships.
  Throws:
    `IfsException` - on failure
  (Unpublished)

### getParentBranchRelationships

    public BranchRelationship[] getParentBranchRelationships(ClassObject relClass,
                                                             SortSpecification sortSpec)
                                                      throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a child (the other series are the parent).

  Parameters:
    `relClass` - - a ClassObject on which to filter. Must be a subclass of BranchRelationship.
    `sortSpec` - - order to sort BranchRelationships
  Returns:
    an array of parent branch relationships.
  Throws:
    `IfsException` - on failure
  (Unpublished)

### getChildBranchRelationships

    public BranchRelationship[] getChildBranchRelationships()
                                                     throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a parent (the other series are the child).

  Returns:
    array of child branch relationships.
  Throws:
    `IfsException` - on failure
  (Unpublished)

### getChildBranchRelationships

    public BranchRelationship[] getChildBranchRelationships(ClassObject relClass,
                                                            SortSpecification sortSpec)
                                                     throws IfsException

  Description copied from class: `VersionSeries`
  Returns an array of BranchRelationships that describe branch or integrate operations involving this VersionSeries as a parent (the other series are the child).

  Parameters:
    `relClass` - - a ClassObject on which to filter. Must be a subclass of BranchRelationship.
    `sortSpec` - - order to sort BranchRelationships
  Returns:
    an array of child branch relationships.
  Throws:
    `IfsException` - on failure
  (Unpublished)

### resetVersionDescriptions

    protected void resetVersionDescriptions()
                                     throws IfsException

  Description copied from class: `VersionSeries`
  Clear locally cached list of Versions.

  Throws:
    `IfsException` - on failure
  (Unpublished)

### isVersioned

    public boolean isVersioned()
                        throws IfsException

  Description copied from class: `VersionSeries`
  Returns false always. This class of object is not versionable.

  Overrides:
    `isVersioned` in class `PublicObject`
  Returns:
    false always. This object is not versionable.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### constructVersionSeriesVector

    protected static java.util.Vector constructVersionSeriesVector(LibrarySession sess,
                                                                   java.util.Vector vector)
                                                            throws IfsException

  Description copied from class: `VersionSeries`
  Constructs a vector of VersionSeries objects from a vector of data objects corresponding to it.

  Parameters:
    `sess` - handle to the session
    `vector` - vector of data objects
  Returns:
    vector of VersionSeries
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructVersionSeries

    protected static VersionSeries constructVersionSeries(LibrarySession sess,
                                                          S_LibraryObjectData data)
                                                   throws IfsException

  Description copied from class: `VersionSeries`
  Constructs a VersionSeries from data corresponding to it.

  Parameters:
    `sess` - handle to the session
    `data` - data corresponding to the object
  Returns:
    VersionSeries object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructVersionSeriesArray

    protected static VersionSeries[] constructVersionSeriesArray(LibrarySession sess,
                                                                 java.lang.Long[] ids)
                                                          throws IfsException

  Description copied from class: `VersionSeries`
  Construct a Version Series array from an array of object IDs. This will throw an exception if any of the IDs cannot be converted into a Version Series Object.

  Parameters:
    `sess` - the requesting session
    `ids` - the array of object IDs
  Returns:
    the array of Version Series
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### vectorToVersionSeriesArray

    protected static VersionSeries[] vectorToVersionSeriesArray(java.util.Vector vector)

  Description copied from class: `VersionSeries`
  Returns an array of VersionSeries objects from a vector of VersionSeries objects.

  Parameters:
    `vector` - Vector of VersionSeries objects
  Returns:
    array of VersionSeries objects
  (Unpublished)

### vectorVersionSeriesElement

    protected static VersionSeries vectorVersionSeriesElement(java.util.Vector vector,
                                                              int index)

  Description copied from class: `VersionSeries`
  Get a VersionSeries out of a Vector of VersionSeries. Used in Family and in this class.

  Parameters:
    `vector` - Vector of VersionSeries objects
    `index` - zero-based index into the Vector
  Returns:
    the requested VersionSeries.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if there is no object at the specified index.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD